# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ftm_msgs/FTMRange.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class FTMRange(genpy.Message):
  _md5sum = "7354764b9c57ad804e17cec4361b21e3"
  _type = "ftm_msgs/FTMRange"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header
string host_mac		# The mac address of the station that performed the FTM range measurements
string target_mac	# The mac address of the station with which the FTM range measurements was performed
int64 rtt		
uint64 rtt_var
uint64 rtt_spread
float32 range		# The range that was measured
uint64 range_var	
uint64 range_spread
int8 rssi
uint8 rssi_spread

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id
"""
  __slots__ = ['header','host_mac','target_mac','rtt','rtt_var','rtt_spread','range','range_var','range_spread','rssi','rssi_spread']
  _slot_types = ['std_msgs/Header','string','string','int64','uint64','uint64','float32','uint64','uint64','int8','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,host_mac,target_mac,rtt,rtt_var,rtt_spread,range,range_var,range_spread,rssi,rssi_spread

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(FTMRange, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.host_mac is None:
        self.host_mac = ''
      if self.target_mac is None:
        self.target_mac = ''
      if self.rtt is None:
        self.rtt = 0
      if self.rtt_var is None:
        self.rtt_var = 0
      if self.rtt_spread is None:
        self.rtt_spread = 0
      if self.range is None:
        self.range = 0.
      if self.range_var is None:
        self.range_var = 0
      if self.range_spread is None:
        self.range_spread = 0
      if self.rssi is None:
        self.rssi = 0
      if self.rssi_spread is None:
        self.rssi_spread = 0
    else:
      self.header = std_msgs.msg.Header()
      self.host_mac = ''
      self.target_mac = ''
      self.rtt = 0
      self.rtt_var = 0
      self.rtt_spread = 0
      self.range = 0.
      self.range_var = 0
      self.range_spread = 0
      self.rssi = 0
      self.rssi_spread = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.host_mac
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.target_mac
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_q2Qf2QbB().pack(_x.rtt, _x.rtt_var, _x.rtt_spread, _x.range, _x.range_var, _x.range_spread, _x.rssi, _x.rssi_spread))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.host_mac = str[start:end].decode('utf-8')
      else:
        self.host_mac = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_mac = str[start:end].decode('utf-8')
      else:
        self.target_mac = str[start:end]
      _x = self
      start = end
      end += 46
      (_x.rtt, _x.rtt_var, _x.rtt_spread, _x.range, _x.range_var, _x.range_spread, _x.rssi, _x.rssi_spread,) = _get_struct_q2Qf2QbB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.host_mac
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.target_mac
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_q2Qf2QbB().pack(_x.rtt, _x.rtt_var, _x.rtt_spread, _x.range, _x.range_var, _x.range_spread, _x.rssi, _x.rssi_spread))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.host_mac = str[start:end].decode('utf-8')
      else:
        self.host_mac = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_mac = str[start:end].decode('utf-8')
      else:
        self.target_mac = str[start:end]
      _x = self
      start = end
      end += 46
      (_x.rtt, _x.rtt_var, _x.rtt_spread, _x.range, _x.range_var, _x.range_spread, _x.rssi, _x.rssi_spread,) = _get_struct_q2Qf2QbB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_q2Qf2QbB = None
def _get_struct_q2Qf2QbB():
    global _struct_q2Qf2QbB
    if _struct_q2Qf2QbB is None:
        _struct_q2Qf2QbB = struct.Struct("<q2Qf2QbB")
    return _struct_q2Qf2QbB
