// Auto-generated. Do not edit!

// (in-package ftm_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let LCIData = require('./LCIData.js');

//-----------------------------------------------------------

class LCIRegistryEntry {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.stamp = null;
      this.has_lci = null;
      this.lci_data = null;
    }
    else {
      if (initObj.hasOwnProperty('stamp')) {
        this.stamp = initObj.stamp
      }
      else {
        this.stamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('has_lci')) {
        this.has_lci = initObj.has_lci
      }
      else {
        this.has_lci = false;
      }
      if (initObj.hasOwnProperty('lci_data')) {
        this.lci_data = initObj.lci_data
      }
      else {
        this.lci_data = new LCIData();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type LCIRegistryEntry
    // Serialize message field [stamp]
    bufferOffset = _serializer.time(obj.stamp, buffer, bufferOffset);
    // Serialize message field [has_lci]
    bufferOffset = _serializer.bool(obj.has_lci, buffer, bufferOffset);
    // Serialize message field [lci_data]
    bufferOffset = LCIData.serialize(obj.lci_data, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type LCIRegistryEntry
    let len;
    let data = new LCIRegistryEntry(null);
    // Deserialize message field [stamp]
    data.stamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [has_lci]
    data.has_lci = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [lci_data]
    data.lci_data = LCIData.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += LCIData.getMessageSize(object.lci_data);
    return length + 9;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ftm_msgs/LCIRegistryEntry';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'bad8b985cf1fd415a4f1b774c83d2185';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    time stamp	# The timestamp of the insertion
    bool has_lci	# Indicates if entry has lci (to allow saving devices that support FTM but has no LCI data)
    LCIData lci_data
    
    ================================================================================
    MSG: ftm_msgs/LCIData
    string mac
    string raw			# data is valid only if raw is not empty
    float32 latitude
    float32 latitude_uncertainty
    float32 longitude
    float32 longitude_uncertainty
    uint8 ALTITUDE_TYPE_UNKNOWN = 0	# No Known Altitude
    uint8 ALTITUDE_TYPE_METERS = 0	# Altitude in Meters
    uint8 ALTITUDE_TYPE_FLOORS = 0	# Altitude in Floors
    uint8 altitude_type
    float32 altitude
    float32 altitude_uncertainty
    uint8 DATUM_WGS84 = 1
    uint8 DATUM_NAD83_NAVD88 = 2
    uint8 DATUM_NAD83_MLLW = 3
    uint8 datum
    bool reg_loc_agreement
    bool reg_loc_dse
    bool dependent_sta
    uint8 version
    bool has_floor_information        
    uint8 expected_to_move
    float32 sta_floor_number	# 512 indicates unknown floor number, 511.9375 indicates 511.9375 floors or more, -511.9375 indicates -511.9375 floors or less
    float32 sta_height_above_floor	# 2048 indicates unknown height, 2047.9997... indicates 2047.999m or more, -2047.9997... indicates -2047.999m or less
    float32 sta_height_above_floor_uncertainty	# 0 indicates unknown uncertainty, negative value is the negation of a reserved value (25 or higher)
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new LCIRegistryEntry(null);
    if (msg.stamp !== undefined) {
      resolved.stamp = msg.stamp;
    }
    else {
      resolved.stamp = {secs: 0, nsecs: 0}
    }

    if (msg.has_lci !== undefined) {
      resolved.has_lci = msg.has_lci;
    }
    else {
      resolved.has_lci = false
    }

    if (msg.lci_data !== undefined) {
      resolved.lci_data = LCIData.Resolve(msg.lci_data)
    }
    else {
      resolved.lci_data = new LCIData()
    }

    return resolved;
    }
};

module.exports = LCIRegistryEntry;
