// Auto-generated. Do not edit!

// (in-package ftm_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let LCIData = require('./LCIData.js');

//-----------------------------------------------------------

class LCIRegistryUpdate {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.stamp = null;
      this.mac = null;
      this.lci_data = null;
      this.status = null;
    }
    else {
      if (initObj.hasOwnProperty('stamp')) {
        this.stamp = initObj.stamp
      }
      else {
        this.stamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('mac')) {
        this.mac = initObj.mac
      }
      else {
        this.mac = '';
      }
      if (initObj.hasOwnProperty('lci_data')) {
        this.lci_data = initObj.lci_data
      }
      else {
        this.lci_data = new LCIData();
      }
      if (initObj.hasOwnProperty('status')) {
        this.status = initObj.status
      }
      else {
        this.status = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type LCIRegistryUpdate
    // Serialize message field [stamp]
    bufferOffset = _serializer.time(obj.stamp, buffer, bufferOffset);
    // Serialize message field [mac]
    bufferOffset = _serializer.string(obj.mac, buffer, bufferOffset);
    // Serialize message field [lci_data]
    bufferOffset = LCIData.serialize(obj.lci_data, buffer, bufferOffset);
    // Serialize message field [status]
    bufferOffset = _serializer.uint8(obj.status, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type LCIRegistryUpdate
    let len;
    let data = new LCIRegistryUpdate(null);
    // Deserialize message field [stamp]
    data.stamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [mac]
    data.mac = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [lci_data]
    data.lci_data = LCIData.deserialize(buffer, bufferOffset);
    // Deserialize message field [status]
    data.status = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.mac.length;
    length += LCIData.getMessageSize(object.lci_data);
    return length + 13;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ftm_msgs/LCIRegistryUpdate';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '4dff1e45d73cdbf8395cd5a510a76fea';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    time stamp		# The timestamp of the recent change
    string mac		# The mac of the device that has received update
    LCIData lci_data
    uint8 STATUS_ADDED = 0
    uint8 STATUS_UPDATED = 1
    uint8 STATUS_DELETED = 2
    uint8 status
    
    ================================================================================
    MSG: ftm_msgs/LCIData
    string mac
    string raw			# data is valid only if raw is not empty
    float32 latitude
    float32 latitude_uncertainty
    float32 longitude
    float32 longitude_uncertainty
    uint8 ALTITUDE_TYPE_UNKNOWN = 0	# No Known Altitude
    uint8 ALTITUDE_TYPE_METERS = 0	# Altitude in Meters
    uint8 ALTITUDE_TYPE_FLOORS = 0	# Altitude in Floors
    uint8 altitude_type
    float32 altitude
    float32 altitude_uncertainty
    uint8 DATUM_WGS84 = 1
    uint8 DATUM_NAD83_NAVD88 = 2
    uint8 DATUM_NAD83_MLLW = 3
    uint8 datum
    bool reg_loc_agreement
    bool reg_loc_dse
    bool dependent_sta
    uint8 version
    bool has_floor_information        
    uint8 expected_to_move
    float32 sta_floor_number	# 512 indicates unknown floor number, 511.9375 indicates 511.9375 floors or more, -511.9375 indicates -511.9375 floors or less
    float32 sta_height_above_floor	# 2048 indicates unknown height, 2047.9997... indicates 2047.999m or more, -2047.9997... indicates -2047.999m or less
    float32 sta_height_above_floor_uncertainty	# 0 indicates unknown uncertainty, negative value is the negation of a reserved value (25 or higher)
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new LCIRegistryUpdate(null);
    if (msg.stamp !== undefined) {
      resolved.stamp = msg.stamp;
    }
    else {
      resolved.stamp = {secs: 0, nsecs: 0}
    }

    if (msg.mac !== undefined) {
      resolved.mac = msg.mac;
    }
    else {
      resolved.mac = ''
    }

    if (msg.lci_data !== undefined) {
      resolved.lci_data = LCIData.Resolve(msg.lci_data)
    }
    else {
      resolved.lci_data = new LCIData()
    }

    if (msg.status !== undefined) {
      resolved.status = msg.status;
    }
    else {
      resolved.status = 0
    }

    return resolved;
    }
};

// Constants for message
LCIRegistryUpdate.Constants = {
  STATUS_ADDED: 0,
  STATUS_UPDATED: 1,
  STATUS_DELETED: 2,
}

module.exports = LCIRegistryUpdate;
