// Auto-generated. Do not edit!

// (in-package ftm_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let LCIData = require('../msg/LCIData.js');

//-----------------------------------------------------------


//-----------------------------------------------------------

class AddLCIRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.lci_data_list = null;
    }
    else {
      if (initObj.hasOwnProperty('lci_data_list')) {
        this.lci_data_list = initObj.lci_data_list
      }
      else {
        this.lci_data_list = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type AddLCIRequest
    // Serialize message field [lci_data_list]
    // Serialize the length for message field [lci_data_list]
    bufferOffset = _serializer.uint32(obj.lci_data_list.length, buffer, bufferOffset);
    obj.lci_data_list.forEach((val) => {
      bufferOffset = LCIData.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type AddLCIRequest
    let len;
    let data = new AddLCIRequest(null);
    // Deserialize message field [lci_data_list]
    // Deserialize array length for message field [lci_data_list]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.lci_data_list = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.lci_data_list[i] = LCIData.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.lci_data_list.forEach((val) => {
      length += LCIData.getMessageSize(val);
    });
    return length + 4;
  }

  static datatype() {
    // Returns string type for a service object
    return 'ftm_msgs/AddLCIRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '47fdd5c279be4510f6c35d10e5083614';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    LCIData[] lci_data_list
    
    ================================================================================
    MSG: ftm_msgs/LCIData
    string mac
    string raw			# data is valid only if raw is not empty
    float32 latitude
    float32 latitude_uncertainty
    float32 longitude
    float32 longitude_uncertainty
    uint8 ALTITUDE_TYPE_UNKNOWN = 0	# No Known Altitude
    uint8 ALTITUDE_TYPE_METERS = 0	# Altitude in Meters
    uint8 ALTITUDE_TYPE_FLOORS = 0	# Altitude in Floors
    uint8 altitude_type
    float32 altitude
    float32 altitude_uncertainty
    uint8 DATUM_WGS84 = 1
    uint8 DATUM_NAD83_NAVD88 = 2
    uint8 DATUM_NAD83_MLLW = 3
    uint8 datum
    bool reg_loc_agreement
    bool reg_loc_dse
    bool dependent_sta
    uint8 version
    bool has_floor_information        
    uint8 expected_to_move
    float32 sta_floor_number	# 512 indicates unknown floor number, 511.9375 indicates 511.9375 floors or more, -511.9375 indicates -511.9375 floors or less
    float32 sta_height_above_floor	# 2048 indicates unknown height, 2047.9997... indicates 2047.999m or more, -2047.9997... indicates -2047.999m or less
    float32 sta_height_above_floor_uncertainty	# 0 indicates unknown uncertainty, negative value is the negation of a reserved value (25 or higher)
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new AddLCIRequest(null);
    if (msg.lci_data_list !== undefined) {
      resolved.lci_data_list = new Array(msg.lci_data_list.length);
      for (let i = 0; i < resolved.lci_data_list.length; ++i) {
        resolved.lci_data_list[i] = LCIData.Resolve(msg.lci_data_list[i]);
      }
    }
    else {
      resolved.lci_data_list = []
    }

    return resolved;
    }
};

class AddLCIResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.status = null;
    }
    else {
      if (initObj.hasOwnProperty('status')) {
        this.status = initObj.status
      }
      else {
        this.status = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type AddLCIResponse
    // Serialize message field [status]
    bufferOffset = _serializer.uint8(obj.status, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type AddLCIResponse
    let len;
    let data = new AddLCIResponse(null);
    // Deserialize message field [status]
    data.status = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a service object
    return 'ftm_msgs/AddLCIResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '284aa12dd9e9e760802ac9f38036ea5e';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    uint8 status
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new AddLCIResponse(null);
    if (msg.status !== undefined) {
      resolved.status = msg.status;
    }
    else {
      resolved.status = 0
    }

    return resolved;
    }
};

module.exports = {
  Request: AddLCIRequest,
  Response: AddLCIResponse,
  md5sum() { return 'fb36b37a997ff658a5f9c6ddd624baf5'; },
  datatype() { return 'ftm_msgs/AddLCI'; }
};
